/*
    DB_DEM11.PRG
*/

#include "inkey.ch"
#include "browse.ch"

#define KEYS {;
               asc( "E" ),;
               asc( "e" ),;
               asc( "A" ),;
               asc( "a" ),;
               asc( "D" ),;
               asc( "d" ),;
               asc( "R" ),;
               asc( "r" ),;
               asc( "P" ),;
               asc( "p" );
             }
#define SPOTS   {;
                  {24,0,24,23},;
                  {24,0,24,23},;
                  {24,25,24,31},;
                  {24,25,24,31},;
                  {24,33,24,42},;
                  {24,33,24,42},;
                  {24,44,24,53},;
                  {24,44,24,53},;
                  {24,55,24,79},;
                  {24,55,24,79};
                }


#define REFRESHALL      .t.
#define REFRESHCURRENT  .f.,.f.
//---------
func main()
local aBottomScn
local bDispBegin := {|e| dispbegin()}
local bDispEnd := {|e| aBottomScn := ADsavescn( 22,0,24,79 ),;
                       Xdisp11_recno(),;
                       Xdisp11_menu(),;
                       dispend();
                  }
local bUndisplay := {|e| ADrestscn( aBottomScn )}
local bConfig := {|e| ADdb_extra( e, bDispBegin, bDispEnd, bUndisplay ),;
                      ADdb_move( e, {|e|Xdisp11_recno()} ),;
                      ADdb_keys( e, KEYS, {|e,nth,nkey| Xhandler(e,nth)} ),;
                      ADdb_lbuttons( e, SPOTS, {|e,nth,mrow,mcol| Xhandler(e,nth)} );
                 }

use demo
ADdbview( 0,0,21,79, bConfig )
return nil


//-----------------
func Xdisp11_recno()
static nRecPos
local cColor := if( iscolor(), "GR+/W", "N/W" )
local nRow := row(), nCol := col()

if nRecPos = nil
    nRecPos = 65
    setpos( 22, 0 )
    dispout( space(80), cColor )
    setpos( 22, 1 )
    dispout( "ADdbview() Demonstration Program by The Programmer's Desk", cColor )
endif

setpos( 22, nRecPos )
dispout( padl( alltrim( str( recno() ) ) + "/" +;
               alltrim( str( lastrec() ) ) +;
               if( deleted(), "*", "" ), 14 ),;
         cColor )
setpos( nRow, nCol )
return nil


//---------------
func Xdisp11_menu()
local cColor := if( iscolor(), "R/W", "W+/N" )

setpos( 23, 0 )
dispout( "", cColor )
setpos( 24, 0 )
dispout( "                  Edit    Add    Delete    Recall    Pack                   ", cColor )
return nil

//---------------------
func Xhandler( e, nth )

if nth < 3
    Xedit11(e)
elseif nth < 5
    Xadd11(e)
elseif nth < 7
    delete
    Xdisp11_recno()
elseif nth < 9
    recall
    Xdisp11_recno()
else
    pack
    ADdb_stabilize(e, REFRESHALL )
    Xdisp11_recno()
endif
return nil

//-----------
func Xedit11(e)
field func_name, mouseable, param_num, descriptn, latest_upd
local cColor := setcolor( if( iscolor(), "B/BG, GR+/R", "W+/N, N/W" ) ) 
local nT := 10, nL := 10, nB := 16, nR := 69
local aScn := ADbox( nT, nL, nB, nR )
local cFuncName := func_name, lMouse := mouseable, nParam := param_num
local mDesc := descriptn, dUpdate := latest_upd
local getlist[0], aReadRetval
local bUpdated := {|a| ascan( a[1], .t. ) > 0 .and. ascan( { RX_ABORT, K_ESC }, a[2] ) = 0 }

@nT+1, nL+2 say "Function name         " adget cFuncName
@nT+2, nL+2 say "Is it mouseable?      " adget lMouse picture "Y"
@nT+3, nL+2 say "Number of parameters  " adget nParam
@nT+4, nL+2 say "Description           " adget mDesc picture "@S33"
ADr_expget( getlist,,, .f. )
@nT+5, nL+2 say "Date last updated     " adget dUpdate
aReadRetval = ADread( getlist )

if eval( bUpdated, aReadRetval )
    func_name = cFuncName
    mouseable = lMouse
    param_num = nParam
    descriptn = mDesc
    latest_upd = dUpdate
    ADdb_stabilize( e, REFRESHCURRENT )
endif

setcolor( cColor )
ADrestscn( aScn )
return nil

//----------
func Xadd11(e)
field func_name, mouseable, param_num, descriptn, latest_upd
local cColor := setcolor( if( iscolor(), "B/BG, GR+/R", "W+/N, N/W" ) ) 
local nT := 10, nL := 10, nB := 16, nR := 69
local aScn := ADbox( nT, nL, nB, nR )
local cFuncName, lMouse, nParam, mDesc, dUpdate, nRecno := recno()
local getlist[0], aReadRetval
local bUpdated := {|a| ascan( a[1], .t. ) > 0 .and. ascan( { RX_ABORT, K_ESC }, a[2] ) = 0 }

dbgobottom(); dbskip()
cFuncName = func_name; lMouse := mouseable; nParam := param_num
mDesc := space(80); dUpdate := latest_upd

@nT+1, nL+2 say "Function name         " adget cFuncName
@nT+2, nL+2 say "Is it mouseable?      " adget lMouse picture "Y"
@nT+3, nL+2 say "Number of parameters  " adget nParam
@nT+4, nL+2 say "Description           " adget mDesc picture "@S33"
ADr_expget( getlist,,, .f. )
@nT+5, nL+2 say "Date last updated     " adget dUpdate
aReadRetval = ADread( getlist )

if eval( bUpdated, aReadRetval )
    append blank
    func_name = cFuncName
    mouseable = lMouse
    param_num = nParam
    descriptn = mDesc
    latest_upd = dUpdate
    ADdb_stabilize( e, REFRESHALL )
    Xdisp11_recno()
else
    dbgoto( nRecno )
endif

setcolor( cColor )
ADrestscn( aScn )
return nil

