/*
    DB_DEM13.PRG

    This sample program demonstrates how you can hot-key the PLUS and MINUS
    keys to increment and decrement numeric and date fields.
*/

#define K_PLUS          43
#define K_CTRL_PLUS     400
#define K_ALT_PLUS      334
#define K_MINUS         45
#define K_CTRL_MINUS    398
#define K_ALT_MINUS     330

//---------------
func main( cDbf )
local bConfig := {|e| ADdb_keys( e, { K_PLUS,;
                                      K_CTRL_PLUS,;
                                      K_ALT_PLUS,;
                                      K_MINUS,;
                                      K_CTRL_MINUS,;
                                      K_ALT_MINUS },;
                                    { |e,nth,nkey| Xkeys13( e,nkey )} )}
local aScn

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

aScn = ADmessage( {;
                     "Press the 'PLUS' key to increment  PARAM_NUM by 1 unit",;
                     "                                   LATEST_UPD by 1 day",;
                     "          'CTRL-PLUS' to increment PARAM_NUM by 10 units",;
                     "                                   LATEST_UPD by 1 week",;
                     "           'ALT-PLUS' to increment PARAM_NUM by 100 units",;
                     "                                   LATEST_UPD by 1 month",;
                     "",;
                     "Press the corresponding 'MINUS' keys to decrement";
                   }, 12,, .f., .f. )
                    
ADdbview( 0,0,10,79, bConfig )
ADrestscn( aScn )
return nil


//------------------
func Xkeys13( e, nKey )
local cType := ADdb_fldtype( e )

if cType $ "ND"
    if nKey = K_PLUS
        ADdb_fldput( e, ADdb_fldget(e) + 1 )
    elseif nKey = K_CTRL_PLUS
        ADdb_fldput( e, ADdb_fldget(e) + if( cType == "N", 10, 7 ) )
    elseif nKey = K_ALT_PLUS
        if cType == "N"
            ADdb_fldput( e, ADdb_fldget(e) + 100 )
        else
            ADdb_fldput( e, ADnextmonth( ADdb_fldget(e) ) )
        endif
    elseif nKey = K_MINUS
        ADdb_fldput( e, ADdb_fldget(e) - 1 )
    elseif nKey = K_CTRL_MINUS
        ADdb_fldput( e, ADdb_fldget(e) - if( cType == "N", 10, 7 ) )
    elseif nKey = K_ALT_MINUS
        if cType == "N"
            ADdb_fldput( e, ADdb_fldget(e) - 100 )
        else
            ADdb_fldput( e, ADprevmonth( ADdb_fldget(e) ) )
        endif
    endif
else
    tone(100,1)
endif
return nil


