/*
    DB_DEMO2.PRG

    This sample program changes the default db box attributes and the
    memoedit box attributes.

    Note the following:

    1.  The db box coordinates are changed by directly passing parameters
        in ADdbview().
    2.  The db box frame, color and other attributes changes are made
        known to the engine via the APIs, ADdb_box() and ADdb_color().
    3.  The memoedit attributes changes are made known to the engine via
        the API, ADdb_memo().
    4.  The API messages are sent to ADdbview() via the Configuration
        Specifier, [bConfig].

    See also the files:

    SYNTAX.DB - for an explanation of [bConfig].
    CONFIG.DB - for a full description of the APIs.
*/


//---------------
func main( cDbf )
local bConfig := {|e| ADdb_box( e, "Ŀ ", "Ĵ", "  ", .T., .T. ),;
                      ADdb_color( e, "W+/G", "B/BG" ),;
                      ADdb_memo( e, 0,0,24,76, "B/W", "Ŀ " );
                 }

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

ADdbview( 4,4,20,76, bConfig )
return nil


