/*
    DB_DEMO4.PRG

    Drags the browse box with the arrow keys.

    Note the following:

    1.  The F10 key is configured to initiate the dragging operation.
        The db engine is made aware of this configuration via the API,
        ADdb_keys().
    2.  The API message is sent to the engine via the Configuration
        Specifier, [nConfig].

    See also the files:

    SYNTAX.DB - for an explanation of [bConfig].
    CONFIG.DB - for a full description of the APIs.
*/

#include "inkey.ch"

//---------------
func main( cDbf )
local bConfig := {|e| ADdb_keys( e, { K_F10 }, {|e,nth,nkey| Xkeys(e,nth,nkey)} )}
local aScn

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

aScn = ADmessage( { "Press F10 to drag browse box" }, 22,, .f., .f. )
ADdbview( 4,4,20,76, bConfig )
ADrestscn( aScn )
return nil


//---------------------------------
func Xkeys( e, nth, nkey )
local aScn := ADmessage( {;
                            "Press any key to close this message box...",;
                            "",;
                            "...Then use the arrows to move the browse box.",;
                            "Press Enter when it is in the desired location.",;
                            "Or press Esc to abort.";
                         },,, .f., .f. )

inkey(0)
ADrestscn( aScn )
ADdb_drag( e )
return nil

