/*
    DB_DEMO5.PRG

    Drags the browse box with the mouse.

    Note the following:

    1.  The corners of the browse box are defined as "drag spots". 
        The db engine is made aware of this definitions via the API,
        ADdb_lbuttons().
    2.  The API message is sent to the engine via the Configuration
        Specifier, [nConfig].

    See also the files:

    SYNTAX.DB - for an explanation of [bConfig].
    CONFIG.DB - for a full description of the APIs.
*/


//---------------
func main( cDbf )
local bConfig := {|e| ADdb_lbuttons( e, {;
                                            {4,4,4,4},;
                                            {4,76,4,76},;
                                            {20,4,20,4},;
                                            {20,76,20,76};
                                        },;
                                        {|e,nth,mrow,mcol| Xlbuts5(e,nth,mrow,mcol)};
                                   );
                 }
local aScn

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

aScn = ADmessage( { "Click any corner of the browse box, drag, then release" }, 22,, .f., .f. )
ADdbview( 4,4,20,76, bConfig )
ADrestscn( aScn )
return nil


//---------------------------
func Xlbuts5(e,nth,mRow,mCol)
local nMinimumRows := 4         // the box will not be allowed to go smaller
local nMinimumColumns := 30     // than these

ADdb_mdrag( e, nMinimumRows, nMinimumColumns )

// reset the hot spots since the corners have moved
ADdb_lbuttons( e, {;
                      { ADdb_top(e), ADdb_left(e), ADdb_top(e), ADdb_left(e) },;
                      { ADdb_top(e), ADdb_right(e), ADdb_top(e), ADdb_right(e) },;
                      { ADdb_bottom(e), ADdb_right(e), ADdb_bottom(e), ADdb_right(e) },;
                      { ADdb_bottom(e), ADdb_left(e), ADdb_bottom(e), ADdb_left(e) };
                  };
             )
return nil
