/*
    DB_DEMO8.PRG

    This sample program changes the behaviour of the Esc key, whose default
    behaviour is to signal the db engine to exit.

    Note the following:

    1.  The default behaviour of the Esc key is changed via the API,
        ADdb_escape().
    2.  The API message is sent to ADdbview() via the Configuration
        Specifier, [bConfig].
    3.  Clicking the right button away from the db box sides is equivalent
        to pressing the Esc key.

    See also the files:

    SYNTAX.DB - for an explanation of [bConfig].
    CONFIG.DB - for a full description of the APIs.
*/


//---------------
func main( cDbf )
local bConfig := {|e| ADdb_escape( e, {|e| ADboxmenu( "Exit Browse?", { "No", "Yes" } ) == 2} )}

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

ADdbview( 4,4,20,76, bConfig )
return nil



