/*
    DB_DEMO9.PRG

    This sample program changes the behaviour of the Enter key, whose default
    behaviour is to do nothing.

    Note the following:

    1.  The default behaviour of the Enter key is changed via the API,
        ADdb_enter().  In this demo, the new behaviour is to do a GET.
    2.  The API message is sent to ADdbview() via the Configuration
        Specifier, [bConfig].
    3.  Clicking the field value while it is highlighted is equivalent
        to pressing the Enter key.

    See also the files:

    SYNTAX.DB - for an explanation of [bConfig].
    CONFIG.DB - for a full description of the APIs.
*/


//---------------
func main( cDbf )
local bConfig := {|e| ADdb_enter( e, {|e| ADdb_get( e )} )}

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

ADdbview( 4,4,20,76, bConfig )
return nil



