/*
    DM_TOUR.PRG
*/

#include "inkey.ch"
#include "browse.ch"

//---------------
func main( cDbf )
local nTop := 4, nLeft := 0
local aMenu := {;
                    "Overview: What's the Database Browser Collection?",;
                    "The ADdbview() Syntax",;
                    "Demo: The Basic Implementation",;
                    "Configuring ADdbview() with the APIs",;
                    "Demos: Changing Its Looks",;
                    "Demos: Extending Its Functionality",;
                    "A Quick Syntax Reference";
               }
local aTrigger := { 1,16,11,1,21,22,16 }
local aBlock := {;
                    {|e| ADviewfile( "overview.db" )},;
                    {|e| ADviewfile( "syntax.db" )},;
                    {|e| ADviewfile( "db_demo1.prg", {||Xdemo1()} )},;
                    {|e| ADviewfile( "config.db" )},;
                    {|e| Xlooks(e)},;
                    {|e| Xfunction(e, cDbf)},;
                    {|e| ADviewfile( "quickref.db" )};
                }

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif

Xintro( cDbf )
ADvermenu( nTop, nLeft, aMenu, aTrigger, aBlock )
ADcredit(14,16)
return nil


//------------
func Xlooks(e)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 4
local aMenu := {;
                    "Change the DB and the Memoedit Attributes",;
                    "Add a Title Line Under the DB Box",;
                    "Drag the DB Box with the Arrow Keys",;
                    "Drag the DB Box with the Mouse",;
                    "Add a Horizontal Scroll Bar",;
                    "Add a Vertical Scroll Bar";
               }
local xBlock := {;
                    {|e| ADviewfile( "db_demo2.prg", {||Xdemo2()} )},;
                    {|e| ADviewfile( "db_demo3.prg", {||Xdemo3()} )},;
                    {|e| ADviewfile( "db_demo4.prg", {||Xdemo4()} )},;
                    {|e| ADviewfile( "db_demo5.prg", {||Xdemo5()} )},;
                    {|e| ADviewfile( "db_demo6.prg", {||Xdemo6()} )},;
                    {|e| ADviewfile( "db_demo7.prg", {||Xdemo7()} )};
                }
local aTrigger := { 1, 7, 32, 26, 7, 7 }

ADvermenu( nTop, nLeft, aMenu, aTrigger, xBlock )
return nil


//--------------------
func Xfunction( e, cDbf )
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 4
local aMenu := {;
                    "Ask for Confirmation Before Exiting",;
                    "Do a GET When the Enter Key is Pressed",;
                    "Do an ADGET When the Enter Key is Pressed",;
                    "Attach Typical Edit/Add/Delete/Recall/Pack Features",;
                    "Include a Selected Set of Columns Only",;
                    "Hot-key the +/- Keys to Inc/Dec Numerics and Dates",;
                    "Hide and Unhide a Browse",;
                    "View Child Databases",;
                    "Event Driven ( _sort_of_ ) Browse";
               }
local xBlock := {;
                    {|e| ADviewfile( "db_demo8.prg", {||Xdemo8()} )},;
                    {|e| ADviewfile( "db_demo9.prg", {||Xdemo9()} )},;
                    {|e| ADviewfile( "db_dem10.prg", {||Xdemo10()} )},;
                    {|e| ADviewfile( "db_dem11.prg", {||Xdemo11( cDbf )} )},;
                    {|e| ADviewfile( "db_dem12.prg", {||Xdemo12()} )},;
                    {|e| ADviewfile( "db_dem13.prg", {||Xdemo13()} )},;
                    {|e| ADviewfile( "db_dem14.prg", {||Xdemo14()} )},;
                    {|e| ADviewfile( "db_dem15.prg", {||Xdemo15( cDbf )} )},;
                    {|e| ADviewfile( "db_dem16.prg", {||Xdemo16()} )};
                }
ADvermenu( nTop, nLeft, aMenu, {9,6,7,8,1,13,1,1,1}, xBlock )
return nil


//-----------------
func Xdemo1()
ADdbview()
return nil

//-----------------
func Xdemo2( cDbf )
local bConfig := {|e| ADdb_box( e, "Ŀ ", "Ĵ", "  ", .T., .T. ),;
                      ADdb_color( e, "W+/G", "B/BG" ),;
                      ADdb_memo( e, 0,0,24,79, "B/W", "Ŀ " );
                 }

ADdbview( 4,4,20,76, bConfig )
return nil

//-----------------
func Xdemo3()
local aTitleScn, cTitleColor
local bDispBegin := {|e| dispbegin()}
local bDispEnd := {|e| cTitleColor := if( iscolor(), "GR+/W", "N/W" ),;
                       aTitleScn := ADbox( 24,0,24,79, cTitleColor, "        ", .f., .f. ),;
                       Xdisp3_title( cTitleColor ),;  // displays alias and record number
                       dispend();
                  }
local bUndisplay := {|e| ADrestscn( aTitleScn )}
local bConfig := {|e| ADdb_extra( e, bDispBegin, bDispEnd, bUndisplay ),;
                      ADdb_move( e, {|e| Xdisp3_title( cTitleColor )} );
                 }

ADdbview( 0,0,23,79, bConfig )
return nil


//-----------------------------
func Xdisp3_title( cTitleColor )
local bRecno := {|| " " + padr( alltrim( str( recno() ) ) + "/" + alltrim( str( lastrec() ) ), 15 )}
local nRow := row(), nCol := col()

setpos( 24, 1 )
dispout( alias() + eval( bRecno ), cTitleColor )
setpos( nRow, nCol )
return nil

//-----------
func Xdemo4()
local bConfig := {|e| ADdb_keys( e, { K_F10 }, {|e,nth,nkey| Xkeys4(e,nth,nkey)} )}
local aScn := ADmessage( { "Press F10 to drag browse box" }, 22,, .f., .f. )

ADdbview( 4,4,20,76, bConfig )
ADrestscn( aScn )
return nil


//---------------------------------
func Xkeys4( e, nth, nkey )
local aScn := ADmessage( {;
                            "Press any key to close this message box...",;
                            "",;
                            "...Then use the arrows to move the browse box.",;
                            "Press Enter when it is in the desired location.",;
                            "Or press Esc to abort.";
                         },,, .f., .f. )

inkey(0)
ADrestscn( aScn )
ADdb_drag( e )
return nil

//-----------
func Xdemo5()
local bConfig := {|e| ADdb_lbuttons( e, {;
                                            {4,4,4,4},;
                                            {4,76,4,76},;
                                            {20,4,20,4},;
                                            {20,76,20,76};
                                        },;
                                        {|e,nth,mrow,mcol| Xlbuts5(e,nth,mrow,mcol)};
                                   );
                 }
local aScn

aScn = ADmessage( { "Click any corner of the browse box, drag, then release" }, 22,, .f., .f. )
ADdbview( 4,4,20,76, bConfig )
ADrestscn( aScn )
return nil


//---------------------------
func Xlbuts5(e,nth,mRow,mCol)
local nMinimumRows := 4         // the box will not be allowed to go smaller
local nMinimumColumns := 30     // than these

ADdb_mdrag( e, nMinimumRows, nMinimumColumns )

// reset the hot spots since the corners have moved
ADdb_lbuttons( e, {;
                      { ADdb_top(e), ADdb_left(e), ADdb_top(e), ADdb_left(e) },;
                      { ADdb_top(e), ADdb_right(e), ADdb_top(e), ADdb_right(e) },;
                      { ADdb_bottom(e), ADdb_right(e), ADdb_bottom(e), ADdb_right(e) },;
                      { ADdb_bottom(e), ADdb_left(e), ADdb_bottom(e), ADdb_left(e) };
                  };
             )
return nil


//-----------
func Xdemo6()
local nSBXEngine    // horizontal scroll bar engine
local bDispBegin, bUndisplay
local bDispEnd := { |e| nSBXEngine := ADsbx_create(),;
                        ADsbx_location( e, ADdb_bottom(e), ADdb_left(e) + 1, ADdb_object(e):colcount ),;
                        ADsbx_display( nSBXEngine, ( ADdb_object(e) ):colpos, .f. ),;
                        ADdb_lbuttons( e, { ADsbx_coords( nSBXEngine ) },;
                                          {|e,nth,mRow,mCol| Xlbuts6(e,nth,mRow,mCol, nSBXEngine)};
                                     );
                  }
local bConfig := {|e| ADdb_extra(e, bDispBegin, bDispEnd ),;
                      ADdb_move( e,, {|e| Xxmove6(e, nSBXEngine)} );
                 }

ADdbview( 4,4,20,76, bConfig )
return nil


//-----------------------------------------
func Xlbuts6(e,nth,mRow,mCol,nSBXEngine)
local nDistance, xx

if nth = 1
    nDistance = ADsbx_position( nSBXEngine, mCol ) - ADdb_object(e):colpos

    if nDistance != 0
        if nDistance < 0
            for xx = nDistance to -1
                ADdb_object(e):left()
            next
        elseif nDistance > 0
            for xx = 1 to nDistance
                ADdb_object(e):right()
            next
        endif

        ADdb_object(e):refreshall()
    endif
endif

return nil


//----------------------------
func Xxmove6(e, nSBXEngine)
ADsbx_display( nSBXEngine, ( ADdb_object(e) ):colpos )
return nil
return nil

//-----------
func Xdemo7()
#define SBYENGINE       ADdb_cargo(e)[1]
#define SBYPOSITIONS    ADdb_cargo(e)[2]
#define SBYUNITPOSITION ADdb_cargo(e)[3]
#define LOGNO           ADdb_cargo(e)[4]
#define CARGO_SIZE      4

local nLogno, nLength
local bDispBegin
local bDispEnd := { |e| ADdb_cargo(e, array( CARGO_SIZE ) ),;
                        LOGNO := nLogno := ADlogno(),;
                        nLength := min( ADdb_object(e):rowcount, ADround( lastrec(), ADdb_object(e):rowcount ) ),;
                        SBYENGINE := ADsby_create(),;
                        ADsby_location( SBYENGINE, ADdb_top(e) + ADdb_headlines(e) + 2, ADdb_right(e), nLength ),;
                        SBYPOSITIONS := array( nLength, 2 ),;
                        SBYUNITPOSITION := ADround( lastrec(), nLength ),;
                        Xcalc_sbyunitpositions( e ),;
                        ADsby_display( SBYENGINE, ascan( SBYPOSITIONS, {|x| nLogno >= x[1] .and. nLogno <= x[2]} ), SB_INITIALIZE ),;
                        ADdb_lbuttons( e, {;
                                            ADsby_coords( SBYENGINE );
                                          };
                                     );
                  }
local bUndisplay
local bConfig := {|e| ADdb_lbuttons( e,, {|e,nth,mRow,mCol| Xlbuts7(e,nth,mRow,mCol)} ),;
                      ADdb_move( e, {|e| Xymove7(e)} ),;
                      ADdb_extra( e, bDispBegin, bDispEnd, bUndisplay );
                 }

if lastrec() < 50
    ADmessage( { "Use a database with at least 50 records so the scroll",;
                 "bar may be thoroughly demonstrated." } )
else
    ADdbview( 10,10,20,69, bConfig )
endif
return nil


//---------------------------
func Xlbuts7(e,nth,mRow,mCol)
local nDistance, xx

    LOGNO = SBYPOSITIONS[ADsby_position( SBYENGINE, mRow )][1]
    go top
    skip LOGNO - 1
    ADdb_object(e):refreshall()
    ADdb_vertmove(e, DB_VERTMOVE_UNKNOWN )

return nil

//-------------
func Xymove7(e)
local nVertMove := ADdb_vertmove(e)
local nLogno := LOGNO

if nVertmove = DB_VERTMOVE_UNKNOWN
    ADsby_display( SBYENGINE, ascan( SBYPOSITIONS, {|x| LOGNO >= x[1] .and. LOGNO <= x[2]} ) )
elseif nVertmove = DB_VERTMOVE_BOTTOM
    LOGNO = lastrec()
elseif nVertmove = DB_VERTMOVE_TOP
    LOGNO = 1
else
    LOGNO += nVertmove

    if LOGNO < 1
        LOGNO = 1
    elseif LOGNO > lastrec()
        LOGNO = lastrec()
    endif
endif

if nLogno != LOGNO
    ADsby_display( SBYENGINE, ascan( SBYPOSITIONS, {|x| LOGNO >= x[1] .and. LOGNO <= x[2]} ) )
endif
return nil


//----------------------------------
func Xcalc_sbyunitpositions( e )
local xx

SBYPOSITIONS[1][1] = 1

for xx = 1 to len( SBYPOSITIONS ) - 1
    SBYPOSITIONS[xx][2] = SBYPOSITIONS[xx][1] + SBYUNITPOSITION - 1
    SBYPOSITIONS[xx+1][1] = SBYPOSITIONS[xx][2] + 1
next

SBYPOSITIONS[len (SBYPOSITIONS) ][2] = lastrec()
return nil

//---------
func Xdemo8()
local bConfig := {|e| ADdb_escape( e, {|e| ADboxmenu( "Exit Browse?", { "No", "Yes" } ) == 2} )}

ADdbview( 4,4,20,76, bConfig )
return nil


//---------
func Xdemo9()
local bConfig := {|e| ADdb_enter( e, {|e| ADdb_get( e )} )}

ADdbview( 4,4,20,76, bConfig )
return nil


//---------
func Xdemo10()
local bConfig := {|e| ADdb_enter( e, {|e| ADdb_adget( e )} )}

ADdbview( 4,4,20,76, bConfig )
return nil


#define KEYS {;
               asc( "E" ),;
               asc( "e" ),;
               asc( "A" ),;
               asc( "a" ),;
               asc( "D" ),;
               asc( "d" ),;
               asc( "R" ),;
               asc( "r" ),;
               asc( "P" ),;
               asc( "p" );
             }
#define SPOTS   {;
                  {24,0,24,23},;
                  {24,0,24,23},;
                  {24,25,24,31},;
                  {24,25,24,31},;
                  {24,33,24,42},;
                  {24,33,24,42},;
                  {24,44,24,53},;
                  {24,44,24,53},;
                  {24,55,24,79},;
                  {24,55,24,79};
                }


#define REFRESHALL      .t.
#define REFRESHCURRENT  .f.,.f.

//------------------
func Xdemo11( cDbf )
local aBottomScn
local bDispBegin := {|e| dispbegin()}
local bDispEnd := {|e| aBottomScn := ADsavescn( 22,0,24,79 ),;
                       Xdisp11_recno(),;
                       Xdisp11_menu(),;
                       dispend();
                  }
local bUndisplay := {|e| ADrestscn( aBottomScn )}
local bConfig := {|e| ADdb_extra( e, bDispBegin, bDispEnd, bUndisplay ),;
                      ADdb_move( e, {|e|Xdisp11_recno()} ),;
                      ADdb_keys( e, KEYS, {|e,nth,nkey| Xhandler(e,nth)} ),;
                      ADdb_lbuttons( e, SPOTS, {|e,nth,mrow,mcol| Xhandler(e,nth)} );
                 }

use demo
ADdbview( 0,0,21,79, bConfig )

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif
return nil


//-----------------
func Xdisp11_recno()
static nRecPos
local cColor := if( iscolor(), "GR+/W", "N/W" )
local nRow := row(), nCol := col()

if nRecPos = nil
    nRecPos = 65
    setpos( 22, 0 )
    dispout( space(80), cColor )
    setpos( 22, 1 )
    dispout( "ADdbview() Demonstration Program by The Programmer's Desk", cColor )
endif

setpos( 22, nRecPos )
dispout( padl( alltrim( str( recno() ) ) + "/" +;
               alltrim( str( lastrec() ) ) +;
               if( deleted(), "*", "" ), 14 ),;
         cColor )
setpos( nRow, nCol )
return nil


//---------------
func Xdisp11_menu()
local cColor := if( iscolor(), "R/W", "W+/N" )

setpos( 23, 0 )
dispout( "", cColor )
setpos( 24, 0 )
dispout( "                  Edit    Add    Delete    Recall    Pack                   ", cColor )
return nil

//---------------------
func Xhandler( e, nth )

if nth < 3
    Xedit11(e)
elseif nth < 5
    Xadd11(e)
elseif nth < 7
    delete
    Xdisp11_recno()
elseif nth < 9
    recall
    Xdisp11_recno()
else
    pack
    ADdb_stabilize(e, REFRESHALL )
    Xdisp11_recno()
endif
return nil

//-----------
func Xedit11(e)
field func_name, mouseable, param_num, descriptn, latest_upd
local cColor := setcolor( if( iscolor(), "B/BG, GR+/R", "W+/N, N/W" ) ) 
local nT := 10, nL := 10, nB := 16, nR := 69
local aScn := ADbox( nT, nL, nB, nR )
local cFuncName := func_name, lMouse := mouseable, nParam := param_num
local mDesc := descriptn, dUpdate := latest_upd
local getlist[0], aReadRetval
local bUpdated := {|a| ascan( a[1], .t. ) > 0 .and. ascan( { RX_ABORT, K_ESC }, a[2] ) = 0 }

@nT+1, nL+2 say "Function name         " adget cFuncName
@nT+2, nL+2 say "Is it mouseable?      " adget lMouse picture "Y"
@nT+3, nL+2 say "Number of parameters  " adget nParam
@nT+4, nL+2 say "Description           " adget mDesc picture "@S33"
ADr_expget( getlist,,, .f. )
@nT+5, nL+2 say "Date last updated     " adget dUpdate
aReadRetval = ADread( getlist )

if eval( bUpdated, aReadRetval )
    func_name = cFuncName
    mouseable = lMouse
    param_num = nParam
    descriptn = mDesc
    latest_upd = dUpdate
    ADdb_stabilize( e, REFRESHCURRENT )
endif

setcolor( cColor )
ADrestscn( aScn )
return nil

//----------
func Xadd11(e)
field func_name, mouseable, param_num, descriptn, latest_upd
local cColor := setcolor( if( iscolor(), "B/BG, GR+/R", "W+/N, N/W" ) ) 
local nT := 10, nL := 10, nB := 16, nR := 69
local aScn := ADbox( nT, nL, nB, nR )
local cFuncName, lMouse, nParam, mDesc, dUpdate, nRecno := recno()
local getlist[0], aReadRetval
local bUpdated := {|a| ascan( a[1], .t. ) > 0 .and. ascan( { RX_ABORT, K_ESC }, a[2] ) = 0 }

dbgobottom(); dbskip()
cFuncName = func_name; lMouse := mouseable; nParam := param_num
mDesc := space(80); dUpdate := latest_upd

@nT+1, nL+2 say "Function name         " adget cFuncName
@nT+2, nL+2 say "Is it mouseable?      " adget lMouse picture "Y"
@nT+3, nL+2 say "Number of parameters  " adget nParam
@nT+4, nL+2 say "Description           " adget mDesc picture "@S33"
ADr_expget( getlist,,, .f. )
@nT+5, nL+2 say "Date last updated     " adget dUpdate
aReadRetval = ADread( getlist )

if eval( bUpdated, aReadRetval )
    append blank
    func_name = cFuncName
    mouseable = lMouse
    param_num = nParam
    descriptn = mDesc
    latest_upd = dUpdate
    ADdb_stabilize( e, REFRESHALL )
    Xdisp11_recno()
else
    dbgoto( nRecno )
endif

setcolor( cColor )
ADrestscn( aScn )
return nil


//------------
func Xdemo12()
local bConfig := {|e| ADdb_columns( e, { 1,2 } ) }

ADdbview( 4,4,20,76, bConfig )
return nil


#define K_PLUS          43
#define K_CTRL_PLUS     400
#define K_ALT_PLUS      334
#define K_MINUS         45
#define K_CTRL_MINUS    398
#define K_ALT_MINUS     330

//------------
func Xdemo13()
local bConfig := {|e| ADdb_keys( e, { K_PLUS,;
                                      K_CTRL_PLUS,;
                                      K_ALT_PLUS,;
                                      K_MINUS,;
                                      K_CTRL_MINUS,;
                                      K_ALT_MINUS },;
                                    { |e,nth,nkey| Xkeys13( e,nkey )} )}
local aScn := ADmessage( {;
                            "Press the 'PLUS' key to increment  PARAM_NUM by 1 unit",;
                            "                                   LATEST_UPD by 1 day",;
                            "          'CTRL-PLUS' to increment PARAM_NUM by 10 units",;
                            "                                   LATEST_UPD by 1 week",;
                            "           'ALT-PLUS' to increment PARAM_NUM by 100 units",;
                            "                                   LATEST_UPD by 1 month",;
                            "",;
                            "Press the corresponding 'MINUS' keys to decrement";
                          }, 12,, .f., .f. )
                    
ADdbview( 0,0,10,79, bConfig )
ADrestscn( aScn )
return nil


//------------------
func Xkeys13( e, nKey )
local cType := ADdb_fldtype( e )

if cType $ "ND"
    if nKey = K_PLUS
        ADdb_fldput( e, ADdb_fldget(e) + 1 )
    elseif nKey = K_CTRL_PLUS
        ADdb_fldput( e, ADdb_fldget(e) + if( cType == "N", 10, 7 ) )
    elseif nKey = K_ALT_PLUS
        if cType == "N"
            ADdb_fldput( e, ADdb_fldget(e) + 100 )
        else
            ADdb_fldput( e, ADnextmonth( ADdb_fldget(e) ) )
        endif
    elseif nKey = K_MINUS
        ADdb_fldput( e, ADdb_fldget(e) - 1 )
    elseif nKey = K_CTRL_MINUS
        ADdb_fldput( e, ADdb_fldget(e) - if( cType == "N", 10, 7 ) )
    elseif nKey = K_ALT_MINUS
        if cType == "N"
            ADdb_fldput( e, ADdb_fldget(e) - 100 )
        else
            ADdb_fldput( e, ADprevmonth( ADdb_fldget(e) ) )
        endif
    endif
else
    tone(100,1)
endif
return nil

//------------
func Xdemo14()
local nEngine

nEngine = ADdbview( 4,4,20,76,, .f. )
ADdb_display( nEngine )
ADdb_wait( nEngine )
ADdb_undisplay( nEngine )
ADmessage( { "At this point your program may do anything...",;
             "...then when you are ready..." } )
ADdb_display( nEngine )
ADdb_wait( nEngine )
ADdb_undisplay( nEngine )
return nil


//------------------
func Xdemo15( cDbf )
Xopen15( cDbf )
Xbrowse15()

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif
return nil



//------------
func Xopen15()
field sysnum
use hardware index hardware
select 0
use software index software
select 0
use customer index customer
return nil


//------------
func Xbrowse15()
local nHardware, nSoftware   // db engines
local aScnHardware, aScnSoftware
local bCustomer

nHardware = hardware->( ADdbview(11,0,24,39,, .f.) )
nSoftware = software->( ADdbview(11,40,24,79,, .f.) )
bCustomer := {  |e|;
                ADdb_move( e, {|e| hardware->( dbseek( customer->sysnum ) ),;
                                   hardware->( ADdb_stabilize( nHardware, .t., .t. ) ),;
                                   software->( dbseek( customer->sysnum ) ),;
                                   software->( ADdb_stabilize( nSoftware, .t., .t. ) );
                              };
                          ),;
                ADdb_extra( e, {|e| aScnHardware := hardware->( ADdb_display( nHardware ) ),;
                                    aScnSoftware := software->( ADdb_display( nSoftware ) );
                               };
                          );
             }
ADdbview(0,0,10,79, bCustomer )
ADdb_undisplay( nHardware )
ADdb_undisplay( nSoftware )
ADdb_kill( nHardware )
ADdb_kill( nSoftware )
return nil

//------------------
func Xdemo16( cDbf )
local aDbf:= { "DEMO", "CUSTOMER", "HARDWARE", "SOFTWARE" }
local cTriggers := "DCHSdchs"
local aIcons := Xpainticons()
local aEngines := Xdb_create( aDbf, aIcons, cTriggers )
local aWaitIcon, xx

do while .t.
    aWaitIcon = ADicon_handler( aIcons, cTriggers )

    if aWaitIcon[2] = -1
        exit
    elseif aWaitIcon[2] = 0
    else
        &( aDbf[aWaitIcon[2]] )->( ADdb_display( aEngines[aWaitIcon[2]] ) )
        &( aDbf[aWaitIcon[2]] )->( ADdb_wait( aEngines[aWaitIcon[2]] ) )
        &( aDbf[aWaitIcon[2]] )->( ADdb_undisplay( aEngines[aWaitIcon[2]] ) )
    endif
enddo

for xx = 1 to len( aIcons )
    ADrestscn( aIcons[xx] )
next

if cDbf = nil .or. !file( cDbf + ".dbf" )
    use demo
else
    use ( cDbf )
endif
return nil



//----------------
func Xpainticons()
local a[0]

aadd( a, ADicon(0,0, "Demo", if( iscolor(), "B/BG", "I" ) ) )
aadd( a, ADicon(0,10, "Customer", if( iscolor(), "B/BG", "I" ) ) )
aadd( a, ADicon(0,24, "Hardware", if( iscolor(), "B/BG", "I" ) ) )
aadd( a, ADicon(0,38, "Software", if( iscolor(), "B/BG", "I" ) ) )
return a



//----------------------------------------
func Xdb_create( aDbf, aIcons, cTriggers )
local aTriggers[0], aSpots[0], a[0], xx
local bConfig := {|e| ADdb_keys( e, aTriggers, {|e,nth| Xevents(e,nth)} ),;
                      ADdb_lbuttons( e, aSpots, {|e,nth| Xevents(e,nth)} );
                 }
local aScn := ADmessage( { "Opening databases" },,, .f. )

for xx = 1 to len( cTriggers )
    aadd( aTriggers, asc( substr( cTriggers, xx, 1 ) ) )
next

for xx = 1 to len( aIcons )
    aadd( aSpots, { aIcons[xx][1], aIcons[xx][2], aIcons[xx][3], aIcons[xx][4] } )
next

use

for xx = 1 to len( aDbf )
    select 0
    use ( aDbf[xx] )
    aadd( a, ADdbview( 4, 0, 24, 79, bConfig, .f. ) )
next

ADrestscn( aScn )
return a


//-----------------
func Xevents(e, nth)
if nth = 1 .or. nth = 5
    keyboard "D"
elseif nth = 2 .or. nth = 6
    keyboard "C"
elseif nth = 3 .or. nth = 7
    keyboard "H"
elseif nth = 4 .or. nth = 8
    keyboard "S"
endif

ADdb_exit( e )
return nil

//-----------------
func Xintro( cDbf )

if cDbf = nil
    ADmessage( { "This demo will use DEMO.DBF since you did not pass one" },,, .f., .f. )
    inkey(3)
endif

cls

ADmessage( {;
                "The Database Browser Collection",;
                "A Mouseable and Extensible Browse Engine and APIs",;
                "",;
                "",;
                "Copyright (c) The Programmer's Desk, 1992",;
                "Press any key";
           },,, .f. )
ADwait()
return nil


